﻿--@C:\Users\Usuario\Desktop\GDI\criacaoTabelas.sql;

--SELECT table_name FROM user_tables WHERE table_name not like '%log%' and table_name not like '%$%';  
--SELECT type_name FROM user_types;  

/*
DROP TABLE tab_venda_prod_func;  
DROP TYPE tp_venda_prod_func;  
DROP TABLE tab_compra;      
DROP TYPE tp_compra;  
DROP TABLE tab_usa;  
DROP TYPE tp_usa;  
DROP TABLE tab_produto;  
DROP TABLE tab_desconto;  
DROP TYPE tp_desconto;  
DROP TABLE tab_fabricacao_propria;  
DROP TYPE tp_fabricacao_propria;  
DROP TABLE tab_estoque;  
DROP TYPE tp_estoque;  
DROP TABLE tab_fornecedor;  
DROP TYPE tp_fornecedor;  
DROP TABLE tab_funcionario;  
DROP TYPE tp_funcionario;  
DROP TYPE tp_telefones;  
DROP TYPE tp_endereco;  
*/
DROP TYPE tp_venda_prod_func FORCE;  
DROP TYPE tp_compra FORCE;  
DROP TYPE tp_usa FORCE;  
DROP TYPE tp_desconto FORCE;  
DROP TYPE tp_produto FORCE;
DROP TYPE tp_fabricacao_propria FORCE;  
DROP TYPE tp_estoque FORCE;  
DROP TYPE tp_fornecedor FORCE;  
DROP TYPE tp_funcionario FORCE;  
DROP TYPE tp_telefones FORCE;  
DROP TYPE tp_endereco FORCE;  
DROP TABLE tab_usa;  
DROP TABLE tab_venda_prod_func;  
DROP TABLE tab_compra;   
DROP TABLE tab_produto;     
DROP TABLE tab_desconto;  
DROP TABLE tab_fabricacao_propria;  
DROP TABLE tab_estoque;  
DROP TABLE tab_fornecedor;  
DROP TABLE tab_funcionario;  


--------------------------------------------------------TYPES

--TELEFONE
CREATE OR REPLACE TYPE tp_telefones AS VARRAY(5) OF VARCHAR2(10);  
/
--ENDERECO
CREATE OR REPLACE TYPE tp_endereco AS OBJECT(
	logradouro	VARCHAR2(50),
	bairro		VARCHAR2(20),
	cidade		VARCHAR2(50),
	estado		VARCHAR2(10),
	cep			VARCHAR2(10),
	numero		NUMBER,
	complemento	NUMBER
);  
 /

 
--FUNCIONARIO

CREATE OR REPLACE TYPE tp_funcionario AS OBJECT(
	cpf			NUMBER,
	email		VARCHAR2(35),
	rg			VARCHAR2(7),
	cargo		VARCHAR2(15),
	salario		NUMBER,
	nome		VARCHAR2(30),
	sexo		VARCHAR2(4),
	telefone	tp_telefones,
	endereco	tp_endereco,
	gerente		REF tp_funcionario
);  
/

CREATE TABLE tab_funcionario OF tp_funcionario(
	cpf PRIMARY KEY,
	gerente WITH ROWID REFERENCES tab_funcionario
);  


--PRODUTO
 
CREATE OR REPLACE TYPE tp_produto AS OBJECT (
	codigo		NUMBER,
    descricao	VARCHAR2(20),
    quantidade	NUMBER,
    quant_min	NUMBER,
    preco_venda	NUMBER
) NOT FINAL;  
/

CREATE TABLE tab_produto OF tp_produto(
	codigo	PRIMARY KEY
);  


--FORNECEDOR

CREATE OR REPLACE TYPE tp_fornecedor AS OBJECT(
    cnpj			NUMBER,
    email			VARCHAR2(30),
    razao_social	VARCHAR2(50),
    telefone		tp_telefones,
    endereco		tp_endereco
);      
/

CREATE TABLE tab_fornecedor OF tp_fornecedor(
	cnpj PRIMARY KEY
);  

--COMPRA
CREATE OR REPLACE TYPE tp_compra AS OBJECT(
    data_compra DATE,
    lista_fornecedor REF  tp_fornecedor,
    lista_funcionario REF  tp_funcionario
);  
/    

CREATE TABLE tab_compra OF tp_compra(
	lista_fornecedor WITH ROWID REFERENCES tab_fornecedor,
	lista_funcionario WITH ROWID REFERENCES tab_funcionario
);  

--ESTOQUE
CREATE OR REPLACE TYPE tp_estoque UNDER tp_produto(
	preco_compra NUMBER
);  
/

CREATE TABLE tab_estoque OF tp_estoque(
	codigo PRIMARY KEY
);  

--FABRICACAO PROPRIA

CREATE OR REPLACE TYPE tp_fabricacao_propria UNDER tp_produto(
	receita VARCHAR2(100)
);  
/    
    
CREATE TABLE tab_fabricacao_propria OF tp_fabricacao_propria(
	codigo PRIMARY KEY
);  


--USA
CREATE OR REPLACE TYPE tp_usa AS OBJECT(
    lista_fabr_propria REF  tp_fabricacao_propria,
    lista_estoque REF tp_estoque
);  
/    

CREATE TABLE tab_usa OF tp_usa(
	lista_fabr_propria WITH ROWID REFERENCES tab_fabricacao_propria,
	lista_estoque WITH ROWID REFERENCES tab_estoque
);  


--DESCONTO

CREATE OR REPLACE TYPE tp_desconto AS OBJECT(
	valor NUMBER
);  
/

CREATE TABLE tab_desconto OF tp_desconto(
	valor PRIMARY KEY
);  

--VENDA PRODUTO FUNCIONARIO

CREATE OR REPLACE TYPE tp_venda_prod_func AS OBJECT(
	codigo NUMBER,
	data_venda DATE,
	lista_produto REF  tp_produto,
	lista_funcionario REF  tp_funcionario,
	desconto REF tp_desconto
);  
/
    
CREATE TABLE tab_venda_prod_func OF tp_venda_prod_func(
	codigo PRIMARY KEY,
	lista_produto WITH ROWID REFERENCES tab_produto,
	lista_funcionario WITH ROWID REFERENCES tab_funcionario,
	desconto WITH ROWID REFERENCES tab_desconto
);  


--------------------------------------------------------
