/*
1 Crie um ORDER MEMBER FUNCTION para o tipo fornecedor, que defina razo social e 
cnpj respectivamente como fatores de ordenao. Para testar, faa uma consulta que retorne, 
ordenadamente (ASC), todos os fornecedores que forneceram algum produto em 2011;
*/
ALTER TYPE tp_fornecedor ADD ORDER MEMBER FUNCTION Compara(fornecedor_p IN tp_fornecedor) RETURN NUMBER CASCADE;
--OK!!!!!
CREATE OR REPLACE TYPE BODY tp_fornecedor AS

	ORDER MEMBER FUNCTION Compara(fornecedor_p IN tp_fornecedor) RETURN NUMBER AS	
	BEGIN		
		IF SELF.razao_social = fornecedor_p.razao_social  THEN
			RETURN SELF.cnpj - fornecedor_p.cnpj;
        ELSIF 	SELF.razao_social > fornecedor_p.razao_social THEN
			RETURN -1;
        ELSE
			RETURN 1;
        END IF;  	
	END;
END;

SELECT DEREF(C.lista_fornecedor)
FROM tab_compra C
WHERE C.data_compra BETWEEN TO_DATE('01/01/2011','dd/mm/yyyy') AND TO_DATE('31/12/2011','dd/mm/yyyy')
ORDER BY  DEREF(C.lista_fornecedor);


--DROP
ALTER TYPE tp_fornecedor DROP ORDER MEMBER FUNCTION Compara(fornecedor_p IN tp_fornecedor)  RETURN NUMBER CASCADE; 

/*
2 Crie um MAP MEMBER FUNCTION para o tipo funcionrio, que torna possvel a 
ordenao de uma consulta a partir do nome do funcionrio. Para testar, faa uma consulta 
que retorne, ordenadamente (ASC), todos os funcionrios que moram no bairro "Vrzea";
*/


-- OK!!!!!!!!!!!!!!!!!!!!
ALTER TYPE tp_funcionario ADD MAP MEMBER FUNCTION ordena RETURN VARCHAR2 CASCADE; 

CREATE OR REPLACE TYPE BODY tp_funcionario AS
	MAP MEMBER FUNCTION ordena RETURN VARCHAR2 AS	
	BEGIN
		RETURN SELF.nome;		
	END;
END;

SELECT *
FROM tab_funcionario F
WHERE F.endereco.bairro LIKE 'Varzea';


-- dar o DROP

ALTER TYPE tp_funcionario DROP MAP MEMBER FUNCTION ordena RETURN VARCHAR2 CASCADE; 





/*
3 Consulte os telefones do funcionrio que possui mais nmeros de telefone. (considere que os telefones esto armazenados num VARRAY);
*/
--OK!!!!!!

select telefone from tab_funcionario g where ((select  count(*) as total from table(select telefone from tab_funcionario where cpf=g.cpf))) in
(select max(TOTAL) from (select(select  count(*) as total from table(select telefone from tab_funcionario where cpf=f.cpf)) as total from tab_funcionario f));



/*
5 Liste o nome e a quantidade de todos os produtos vendidos pelo funcionrio "Fulano" 
que foi dado algum desconto e que no  de fabricao prpria, ordene esta consulta pelo 
nome do produto. (use DANGLING);
*/


--OK !!!!!!

SELECT v.lista_produto.descricao,v.lista_produto.quantidade
FROM tab_venda_prod_func V
WHERE V.lista_funcionario.nome LIKE 'Fulano'
 AND V.desconto IS NOT DANGLING
 AND V.desconto.valor > 0
 AND v.lista_produto.codigo IN (SELECT codigo FROM tab_estoque)
ORDER BY V.lista_produto.descricao ASC;

/*
6 Crie uma MEMBER PROCEDURE no tipo funcionrio que exiba o nome e o salrio de 
todos os funcionrios que tem o mesmo cargo que ele;
*/
--OK!!!!!
ALTER TYPE tp_funcionario ADD MEMBER PROCEDURE exibir CASCADE;

CREATE OR REPLACE TYPE BODY tp_funcionario AS

	MEMBER PROCEDURE exibir AS	
	
	CURSOR ccursor IS
	(SELECT T.nome, T.salario
	FROM tab_funcionario T
	WHERE T.cargo = SELF.cargo);
	
	BEGIN
		FOR i IN ccursor LOOP
		
			dbms_output.put_line('Nome: ' || i.nome || ' Salario: ' || i.salario);
		
		END LOOP;			
	END;
	
END;

--testar
DECLARE
	funcionario tp_funcionario;
BEGIN
	funcionario := tp_funcionario(785632416872, NULL,NULL,'Padeiro',NULL,NULL,NULL,NULL,NULL,NULL);
	funcionario.exibir();
END;
-- dar o drop
ALTER TYPE tp_funcionario DROP MAP MEMBER PROCEDURE exibir CASCADE;

/*
7 Crie uma MEMBER PROCEDURE no tipo funcionrio para que seja  passada uma 
porcentagem (ex.: 10 para 10%) de aumento e seja aplicado esse aumento no seu salrio. 
(utiliza SELF);
*/

--OK!!!!!!!


ALTER TYPE tp_funcionario ADD MEMBER PROCEDURE atualizar (porc_p NUMBER) CASCADE;

CREATE OR REPLACE TYPE BODY tp_funcionario AS
	MEMBER PROCEDURE atualizar (porc_p NUMBER) AS	
	BEGIN
		UPDATE tab_funcionario F
	    SET F.salario = F.salario + F.salario * (porc_p/100)
		WHERE F.CPF = SELF.CPF;	
	END;
	
END;		

--TESTAR
DECLARE
	funcionario tp_funcionario;
BEGIN
	funcionario := tp_funcionario(785632416872, NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
	funcionario.atualizar(10);
END;

SELECT nome,salario FROM tab_funcionario WHERE cpf=785632416872;


--drop
ALTER TYPE tp_funcionario DROP MEMBER PROCEDURE atualizar (porc_p NUMBER) CASCADE;



/*
8 Crie uma MEMBER FUNCTION no tipo funcionrio e que recebe uma data e devolve a 
quantidade de vendas e compras realizadas nesta data por este funcionrio;
*/

--OK!!!!!!
ALTER TYPE tp_funcionario ADD MEMBER FUNCTION quantidade(data_p DATE) RETURN NUMBER CASCADE;

CREATE OR REPLACE TYPE BODY tp_funcionario AS

	MEMBER FUNCTION quantidade(data_p DATE) RETURN NUMBER AS	
	qtd_compras NUMBER;
	qtd_vendas NUMBER;
	
	BEGIN				
		SELECT COUNT(*) INTO qtd_compras
		FROM tab_compra T
		WHERE T.lista_funcionario.CPF = SELF.CPF
			  AND T.data_compra = data_p;
			  
		SELECT COUNT(*) INTO qtd_vendas
		FROM tab_venda_prod_func V
		WHERE V.lista_funcionario.CPF = SELF.CPF
		      AND V.data_venda = data_p;
			  
		RETURN qtd_compras + qtd_vendas;
		
	END;
	
END;

--testar
SELECT V.quantidade(to_date('20/03/2012','dd/mm/yyyy'))
FROM tab_funcionario V
WHERE V.cpf=07692396756;



--Drop
ALTER TYPE tp_funcionario DROP MEMBER FUNCTION  quantidade(data_p DATE) RETURN NUMBER CASCADE;

/*
9 Defina um construtor (CONSTRUCTOR FUNCTION) para produtos de estoque que 
receba todos os seus atributos, exceto preo de venda, que ser atribudo automaticamente 
com 30% de acrscimo em relao ao preo de compra;

*/
--OK!!!!!!!!!
ALTER TYPE tp_estoque ADD CONSTRUCTOR FUNCTION tp_estoque(codigo_p NUMBER, descricao_p VARCHAR2, quantidade_p NUMBER, quant_min_p NUMBER, preco_compra_p NUMBER) RETURN SELF AS RESULT CASCADE;                                                                                                        

CREATE OR REPLACE TYPE BODY tp_estoque AS

	CONSTRUCTOR FUNCTION tp_estoque (codigo_p NUMBER, descricao_p VARCHAR2, quantidade_p NUMBER, 	
	quant_min_p NUMBER, preco_compra_p NUMBER) RETURN SELF AS RESULT IS
	
	
	BEGIN
	
	SELF.codigo := codigo_p;
	SELF.descricao := descricao_p;
	SELF.quantidade := quantidade_p;
	SELF.quant_min := quant_min_p;
	SELF.preco_compra := preco_compra_p;
	SELF.preco_venda := 1.3*preco_compra_p;
	
	RETURN;
	END;

END;

--TESTE

DECLARE
  var tp_estoque; 
BEGIN
  var := tp_estoque(18,'Sal cristal',90 , 70, 1); 
  DBMS_OUTPUT.PUT_LINE('Preco compra: ' || var.preco_compra||', Preco venda: '||var.preco_venda);
END;


/*
10 Realize uma consulta que retorne todos os fornecedores que fornecem pelo menos um 
produto que  utilizado na fabricao de "Torta de Chocolate". Apresente nome, email, bairro 
e preo de compra;
*/

SELECT T.lista_funcionario.nome, T.lista_funcionario.email, T.lista_funcionario.endereco.bairro, E.preco_compra
FROM tab_venda_prod_func T, tab_estoque E
WHERE  E.codigo = T.lista_produto.codigo
	   AND
	   T.lista_produto.codigo IN 
								(SELECT U.lista_estoque.codigo FROM tab_usa U WHERE U.lista_fabr_propria.descricao LIKE '%Bolo chocolate%' );

								 
								 
								 
								 










